﻿using DevExpress.Utils.Extensions;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Windows.Forms;

namespace TestPlate
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public class Vehicle
        {
            public int location = 0;
            public DateTime tag;
            public String plate;
            public int country = 0;
            public string platex
            {
                get
                {
                    return plate + "_" + country.ToString();
                }
            }

            public int singles = 0;
            public int tots = 0;

            public static Vehicle FromString(String s)
            {
                try
                {
                    Vehicle v = new Vehicle();
                    String[] pp = s.Split('\t');
                    if (pp.Length == 4)
                    {
                        v.location = int.Parse(pp[0]);
                        v.plate = pp[1];
                        v.tag = DateTime.Parse(pp[2]);
                        v.country = int.Parse(pp[3]);
                        return v;
                    }
                }
                catch
                {

                }
                return null;
            }
        }
        // 3011	EX399YR	2025-02-17 08:40:43	380

        private void button1_Click(object sender, EventArgs e)
        {
            String[] ff = Directory.GetFiles("e:\\work\\lenisa_test", "*.pabtest");

            List<Vehicle> vv = new List<Vehicle>();

            for (int i = 0; i < ff.Length; i++)
            {
                var fln = ff[i];
                var ll = File.ReadAllLines(fln);
                ll.ForEach(l =>
                {
                    Vehicle v = Vehicle.FromString(l);
                    if (v != null) vv.Add(v);
                });
            }


            vv.Sort((a, b) => a.tag.CompareTo(b.tag));

            textBox1.Text = "";
            String r = Parse2(vv);

            textBox1.Text = r;
        }

        static DateTime startTime = DateTime.MinValue;
        
        public void Tag(String n = "")
        {
            if (startTime == DateTime.MinValue)
            {
                startTime = DateTime.Now;
                if (!String.IsNullOrEmpty(n))
                    System.Diagnostics.Debug.WriteLine($"{startTime} {n}");
            }
            else
            {
                DateTime d = DateTime.Now;
                System.Diagnostics.Debug.WriteLine($"{(d - startTime).TotalSeconds} sec {n}");
                startTime = d;
            }
        }
        public class VehiclePlate
        {
            string _plate = String.Empty;
            public string plate
            {
                get
                {
                    return _plate;
                }
                set
                {
                    plate = value;
                    pXX_XXX_XO = XX_XXX_XO;
                    pXX_XXX_OO = XX_XXX_OO;
                    pXX_XXO_OO = XX_XXO_OO;
                    pXX_XXX_OX = XX_XXX_OX;
                    pOX_XXX_XX = OX_XXX_XX;
                    pOO_XXX_XX = OO_XXX_XX;
                    pXO_XXX_XX = XO_XXX_XX;
                    pOO_OXX_XX = OO_OXX_XX;
                    pXX_OOO_XX = XX_OOO_XX;
                }
            }
            public int count = 0;
            public int country = 0;
            public int site = 0;

            public int count1 = 0;

            public string platex
            {
                get
                {
                    return plate + "_" + country.ToString();
                }
            }

            public string explate
            {
                get
                {
                    return "_" + country.ToString();
                }
            }

            public string pXX_XXX_XO, pXX_XXX_OO, pXX_XXO_OO, pXX_XXX_OX, pOX_XXX_XX, pOO_XXX_XX, pXO_XXX_XX, pOO_OXX_XX, pXX_OOO_XX;

            public string XX_XXX_XO
            {
                get
                {
                    return plate.Substring(0, plate.Length - 1);
                }
            }
            public string XX_XXX_OO
            {
                get
                {
                    return plate.Substring(0, plate.Length - 2);
                }
            }
            public string XX_XXO_OO
            {
                get
                {
                    return plate.Substring(0, plate.Length - 3);
                }
            }


            public string XX_XXX_OX
            {
                get
                {
                    return plate.Substring(0, plate.Length - 2) + plate.Substring(plate.Length - 1);
                }
            }

            public string OX_XXX_XX
            {
                get
                {
                    return plate.Substring(1);
                }
            }
            public string OO_XXX_XX
            {
                get
                {
                    return plate.Substring(2);
                }
            }
            public string XO_XXX_XX
            {
                get
                {
                    return plate.Substring(0, 1) + plate.Substring(2);
                }
            }
            public string OO_OXX_XX
            {
                get
                {
                    return plate.Substring(3);
                }
            }
            public string XX_OOO_XX
            {
                get
                {
                    return plate.Substring(0,2) + plate.Substring(plate.Length - 3, 2);
                }
            }

        }

        public class Location
        {
            public int location;
            public int tot = 0;
            public int ita = 0;
            public int singles = 0;
        }

        String Parse2(List<Vehicle> vv)
        {
            Tag("start");
            String r = "";
            r += String.Format("{0}\t{1}\tPeriodo rilevato\r\n", vv.First().tag, vv.Last().tag);
            r += String.Format("{0}\tpassaggi totali rilevati\r\n", vv.Count);

            var vvi = vv.FindAll(x => x.country == 380 || x.country == 1);


            List<Vehicle> vvx = vvi; // vv

            Tag("count ita");

            r += String.Format("{0}\tVeicoli italiani\r\n", vvi.Count);


            var locs = vv.GroupBy(x => x.location).Select(group => group.First());

            List<Location> locss = new List<Location>();
            foreach (var item in locs)
            {
                Location l = new Location();
                l.location = item.location;

                locss.Add(l);
            }


            Tag($"fetched {locs.Count()} locs");


            List<VehiclePlate> plates = new List< VehiclePlate >();
            vvx.Sort((a, b)  => a.plate.CompareTo(b.plate));

            Tag($"sorted {vvx.Count} vehicles");


            /*
            String ls = vvx[0].platex;
            

            plates.Add(new VehiclePlate() { plate = ls, count = 0, site = vvx[0].location, country = vvx[0].country });
            foreach (var v in vvx)
            {
                locss.Find(l => l.location == v.location).tot++;

                if (ls != v.platex)
                {
                    plates.Add(new VehiclePlate() { plate = ls, count = 1, site = v.location, country = v.country });
                    ls = v.platex;
                }
                else plates.Last().count++;
            }

            Tag($"found {plates.Count} unique plates");

            List<VehiclePlate> vp1 = plates.FindAll(v => v.count == 1);

            foreach (var v in vp1)
            {
                locss.Find(l => l.location == v.site).singles++;
            }

            List<VehiclePlate> vp2 = plates.FindAll(v => v.count > 1);


            r += String.Format("{0}\tVeicoli con UN solo passaggio\r\n", plates.Count - vp2.Count);
            Tag($"found {plates.Count - vp2.Count} vehicles WITH ONLY 1 PASSAGE");


            r += String.Format("{0}\tVeicoli con piu passaggi\r\n", vp2.Count);

            vp2 = vp2.FindAll(v => v.plate.Length >= 7);

            r += String.Format("{0}\tVeicoli con piu passaggi E ALMENO 7 DI TARGA\r\n", vp2.Count);


            var vt5l = vp2.GroupBy(x => x.plate.Substring(0, 6) + x.explate).Select(group => group.First());

            var vt4l = vp2.GroupBy(x => x.plate.Substring(0, 5) + x.explate).Select(group => group.First());
            var vt3l = vp2.GroupBy(x => x.plate.Substring(0, 4) + x.explate).Select(group => group.First());

            var vb1l = vp2.GroupBy(x => x.plate.Substring(1) + x.explate).Select(group => group.First());
            var vb2l = vp2.GroupBy(x => x.plate.Substring(2) + x.explate).Select(group => group.First());
            var vb3l = vp2.GroupBy(x => x.plate.Substring(3) + x.explate).Select(group => group.First());


            var vm1l = vp2.GroupBy(x => x.plate.Substring(0, 2) + x.plate.Substring(5, 2) + x.explate).Select(group => group.First());


            r += String.Format("{0}\tVeicoli XX XXX X*\r\n", vt5l.Count());
            r += String.Format("{0}\tVeicoli XX XXX **\r\n", vt4l.Count());
            r += String.Format("{0}\tVeicoli XX XX* **\r\n", vt3l.Count());

            r += String.Format("{0}\tVeicoli *X XXX XX\r\n", vb1l.Count());
            r += String.Format("{0}\tVeicoli ** XXX XX\r\n", vb2l.Count());
            r += String.Format("{0}\tVeicoli ** *XX XX\r\n", vb3l.Count());


            r += String.Format("{0}\tVeicoli XX *** XX\r\n", vm1l.Count());
            */

            
            String ls = vvx[0].plate;
            

            plates.Add(new VehiclePlate() { plate = ls, count = 0, site = vvx[0].location });
            foreach (var v in vvx)
            {
                locss.Find(l => l.location == v.location).tot++;

                if (ls != v.plate)
                {
                    plates.Add(new VehiclePlate() { plate = ls, count = 1, site = v.location });
                    ls = v.plate;
                    
                }
                else plates.Last().count++;
            }
            
            Tag($"found {plates.Count} unique plates");

            List<VehiclePlate> vp1 = plates.FindAll(v => v.count == 1);

            foreach (var v in vp1)
            {
                locss.Find(l => l.location == v.site).singles++;
            }

            List<VehiclePlate> vp2 = plates.FindAll(v => v.count > 1);


            r += String.Format("{0}\tVeicoli con UN solo passaggio\r\n", plates.Count - vp2.Count);
            Tag($"found {plates.Count - vp2.Count} vehicles WITH ONLY 1 PASSAGE");


            r += String.Format("{0}\tVeicoli con piu passaggi\r\n", vp2.Count);

            vp2 = vp2.FindAll(v => v.plate.Length >= 7);

            r += String.Format("{0}\tVeicoli con piu passaggi E ALMENO 7 DI TARGA\r\n", vp2.Count);


            List<VehiclePlate> vpr = new List<VehiclePlate>();

            vp2.ForEach(v => v.count1 = 0);


            for (int i1 = 0; i1 < vp2.Count; i1++)
            {
                var v = vpr.Find(x => x.XX_XXX_XO == vp2[i1].XX_XXX_XO);
                if (v == null) vpr.Add(vp2[i1]);
                else v.count1++;

                if (i1 % 1000 == 0) System.Diagnostics.Debug.WriteLine($"{i1} / {vp2.Count}");
            }

            int c1 = vpr.Count;
            int c2 = 0;
            vpr.ForEach(v => c2 += v.count1);

            r += String.Format("XX XXX X*\t{1}\t{2}\t{3}\r\n", vp2.Count(), c1, c2);

            Tag($"checked for pattern {c1} - {c2}");

            /*

            foreach (var v in vp2)
            {
                locss.Find(l => l.location == v.site).singles++;
            }



            var vt5l = vp2.GroupBy(x => x.plate.Substring(0, 6)).Select(group => group.First());

            var vt4l = vp2.GroupBy(x => x.plate.Substring(0, 5)).Select(group => group.First());
            var vt3l = vp2.GroupBy(x => x.plate.Substring(0, 4)).Select(group => group.First());

            var vb1l = vp2.GroupBy(x => x.plate.Substring(1)).Select(group => group.First());
            var vb2l = vp2.GroupBy(x => x.plate.Substring(2)).Select(group => group.First());
            var vb3l = vp2.GroupBy(x => x.plate.Substring(3)).Select(group => group.First());


            var vm1l = vp2.GroupBy(x => x.plate.Substring(0,2) + x.plate.Substring(5, 2)).Select(group => group.First());


            r += String.Format("{0}\tVeicoli XX XXX X*\r\n", vt5l.Count());
            r += String.Format("{0}\tVeicoli XX XXX **\r\n", vt4l.Count());
            r += String.Format("{0}\tVeicoli XX XX* **\r\n", vt3l.Count());

            r += String.Format("{0}\tVeicoli *X XXX XX\r\n", vb1l.Count());
            r += String.Format("{0}\tVeicoli ** XXX XX\r\n", vb2l.Count());
            r += String.Format("{0}\tVeicoli ** *XX XX\r\n", vb3l.Count());


            r += String.Format("{0}\tVeicoli XX *** XX\r\n", vm1l.Count());
            */
            return r;
        }

        String Parse(List<Vehicle> vv)
        {
            String r = "";
            r += String.Format("{0}\t{1}\tPeriodo rilevato\r\n", vv.First().tag, vv.Last().tag);
            r += String.Format("{0}\tpassaggi totali rilevati\r\n", vv.Count);

            var vvi = vv.FindAll(x => x.country == 380 || x.country == 1);

            r += String.Format("{0}\tVeicoli italiani\r\n", vvi.Count);

            var locs = vv.GroupBy(x => x.location).Select(group => group.First());

            int singles = 0;

            locs.ForEach(loc =>
            {
                int locct = 0, loct = 0;

                var vv2 = vv.FindAll(v => v.location == loc.location);

                var vv3 = vv2.GroupBy(x => x.plate).Select(group => group.First());

                vv3.ForEach(vc =>
                {
                    
                    int ct = vv2.Count(v => v.plate == vc.plate);
                    if (ct == 1)
                    {
                        locct++;
                        singles++;
                    }
                    loct += ct;
                });

                r += String.Format("{0}\t{1}\t{2}\r\n", loc.location, loct, locct);
            });

            r += String.Format("{0}\tveicoli singoli totali\r\n", singles);

            return r;
        }
    }
}
